'''
CF-1.6 changes based on CF-1.5 checker code

implementation of requirements and recommendations from
http://cfconventions.org/Data/cf-documents/requirements-recommendations/requirements-recommendations-1.6.html

this code is an extension of the CF-1.0 checker base code in the cf10 module
and the modifications by the CF-1.1, CF-1.2, CF-1.3, CF-1.4 and CF-1.5 checker codes in the
cf11, cf12, cf13, cf14 and cf15 modules respectively
'''
from CFchecker import cf15

class CF16Tests(cf15.CF15Tests):
    '''
    changes compared to 1.5:
        - new conventions attribute value
    '''
    cf_convention = 'CF-1.6'

    def _setup_run(self, filename):
        '''
        add additional log message about missing "full" CF-1.6 support to message log
        '''

        cf15.CF15Tests._setup_run(self, filename)

        self.msg.info('INIT', 'CF-1.6 tests are not yet fully implemented, therefore  your file is essentially checked against CF-1.5')

# TODO: App. F: The attributes which describe the ellipsoid and prime meridian may be included, when applicable, with any grid mapping.

#    @classmethod
#    def _setup_grid_mappings(cls):
#        '''
#        extend dict of grid mapping names with their allowed attributes
#        '''
#        # get mappings from base class
#        mappings = cf15.CF15Tests._setup_grid_mappings()
#
#        #extend mappings
#        # TODO: update/remove
#        # there is an inconsistency in the CF-1.2 standard about latitude_longitude mapping attributes:
#        # some are listed in an example, but nowhere else, we are using the ones from the example here
#        # as a best guess
#
#        # TODO: implement alternative attributes (like for lambert_cylindrical_equal_area: Either standard_parallel or scale_factor_at_projection_origin)
#        # Map coordinates:
#        # The x (abscissa) and y (ordinate) rectangular coordinates are identified by the standard_name attribute value projection_x_coordinate and projection_y_coordinate respectively.
#        mappings['lambert_cylindrical_equal_area'] = [('longitude_of_central_meridian',),
#                                            ('standard_parallel', 'scale_factor_at_projection_origin'), ('false_easting',), ('false_northing',)]
#        mappings['latitude_longitude'] = ['longitude_of_prime_meridian', 'semi_major_axis', 'inverse_flattening']
#        mappings['vertical_perspective'] = ['latitude_of_projection_origin', 'longitude_of_projection_origin',
#                                            'perspective_point_height', 'false_easting', 'false_northing']
#
#        return mappings
#
#    @classmethod
#    def _setup_grid_mapping_constraints(cls):
#        '''
#        extend constraints dict for grid mapping attributes
#        '''
#        eps = cls.epsilon
#        inf = float('inf')
#
#        # get constraints from base class
#        constraints = cf11.CF11Tests._setup_grid_mapping_constraints()
#
#        # extend constraints
#        # in addition to range and size, a type constraint has been introduced by CF-1.2 as well
#        # ADDITION: the lower limit is not given in the standard, but a radius should be > 0
#        constraints['earth_radius'] =                   ['N', (0+eps, inf), (1,1)]
#        # ADDITION: lower limit should not be negative as f=(a-b)/a cannot be negative for a>=b and a,b>0
#        constraints['inverse_flattening'] =             ['N', (0, inf), (1,1)]
#        constraints['longitude_of_prime_meridian'] =    ['N', (-180.0, 180.0-eps), (1,1)]
#        constraints['perspective_point_height'] =       ['N', (-inf, inf), (1,1)]
#        # ADDITION: lower limit should be > 0 for any ellipsoid
#        constraints['semi_major_axis'] =                ['N', (0+eps, inf), (1,1)]
#        constraints['perspective_point_height'] =       ['N', (-inf, inf), (1,1)]
#        # ADDITION: lower limit should be > 0 for any ellipsoid
#        constraints['semi_minor_axis'] =                ['N', (0+eps, inf), (1,1)]
#
#        return constraints

# TODO:
# CHAP 5:
#The dimensions of each auxiliary coordinate must be a subset of the dimensions of the variable they are attached to, with two exceptions. First, a label variable which will have a trailing dimension for the maximum string length. Second a ragged array (Chapter 9, Discrete sampling geometries and Appendix H) uses special, more indirect, methods to connect the data and coordinates.
