'''
nose unit tests for CFchecker.cf16
'''
import os

from nose import tools as nt

import CFchecker
from CFchecker.errors import CFCheckerError
from CFchecker.cf16 import CF16Tests
import cf15_test
import helpers

class CF16Tests_test(cf15_test.CF15Tests_test):
    '''
    so far exactly the same as the CF-1.5 tests except for conventions attribute
    '''
    test_class = CF16Tests

    @classmethod
    def setup_class(cls):
        cf15_test.CF15Tests_test.setup_class()
        helpers.amend_faulty_ncfile_cf16(os.path.join(cls.tempdir, cls.faulty_file))
        helpers.amend_good_ncfile_cf16(os.path.join(cls.tempdir, cls.good_file))

    def test_run(self):
        '''CF16Tests: run()'''
        cftest = self.test_class(name_table_file=self.test_name_table, tests_to_run=['2.1'])

        # test log entries with empty file and only one test selected(should only be INIT messages)
        cftest.run(os.path.join(self.tempdir, self.empty_file))
        log = cftest.get_messagelog().get_raw_log()
        nt.assert_equals(log, [('INFO', 'INIT', 'running CFchecker version %s' % (CFchecker.__version__,)),
                               ('INFO', 'INIT', 'checking compliance with convention %s' % self.test_class.cf_convention),
                               ('INFO', 'INIT', 'will only run the following tests: 2.1'),
                               ('INFO', 'INIT', 'using standard name table version: 12, ' \
                                                'last modified: 2009-07-06T12:05:02Z'),
                               ('INFO', 'INIT', 'using area type table version: 4, date: 17 May 2016'),
                               ('INFO', 'INIT', 'CF-1.6 tests are not yet fully implemented, therefore  your file is essentially checked against CF-1.5'),
                              ])
        # test if nonexistent file causes error
        nt.assert_raises(CFCheckerError, cftest.run, self.file_noexist)
